/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the codedeploy-2014-10-06.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.CodeDeploy.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.CodeDeploy.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// TriggerConfig Marshaller
    /// </summary>       
    public class TriggerConfigMarshaller : IRequestMarshaller<TriggerConfig, JsonMarshallerContext> 
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="requestObject"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public void Marshall(TriggerConfig requestObject, JsonMarshallerContext context)
        {
            if(requestObject.IsSetTriggerEvents())
            {
                context.Writer.WritePropertyName("triggerEvents");
                context.Writer.WriteArrayStart();
                foreach(var requestObjectTriggerEventsListValue in requestObject.TriggerEvents)
                {
                        context.Writer.Write(requestObjectTriggerEventsListValue);
                }
                context.Writer.WriteArrayEnd();
            }

            if(requestObject.IsSetTriggerName())
            {
                context.Writer.WritePropertyName("triggerName");
                context.Writer.Write(requestObject.TriggerName);
            }

            if(requestObject.IsSetTriggerTargetArn())
            {
                context.Writer.WritePropertyName("triggerTargetArn");
                context.Writer.Write(requestObject.TriggerTargetArn);
            }

        }

        /// <summary>
        /// Singleton Marshaller.
        /// </summary>  
        public readonly static TriggerConfigMarshaller Instance = new TriggerConfigMarshaller();

    }
}