/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the iot-2015-05-28.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.IoT.Model
{
    /// <summary>
    /// Describes a rule.
    /// </summary>
    public partial class TopicRuleListItem
    {
        private DateTime? _createdAt;
        private string _ruleArn;
        private bool? _ruleDisabled;
        private string _ruleName;
        private string _topicPattern;

        /// <summary>
        /// Gets and sets the property CreatedAt. 
        /// <para>
        /// The date and time the rule was created.
        /// </para>
        /// </summary>
        public DateTime CreatedAt
        {
            get { return this._createdAt.GetValueOrDefault(); }
            set { this._createdAt = value; }
        }

        // Check to see if CreatedAt property is set
        internal bool IsSetCreatedAt()
        {
            return this._createdAt.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property RuleArn. 
        /// <para>
        /// The rule ARN.
        /// </para>
        /// </summary>
        public string RuleArn
        {
            get { return this._ruleArn; }
            set { this._ruleArn = value; }
        }

        // Check to see if RuleArn property is set
        internal bool IsSetRuleArn()
        {
            return this._ruleArn != null;
        }

        /// <summary>
        /// Gets and sets the property RuleDisabled. 
        /// <para>
        /// Specifies whether the rule is disabled.
        /// </para>
        /// </summary>
        public bool RuleDisabled
        {
            get { return this._ruleDisabled.GetValueOrDefault(); }
            set { this._ruleDisabled = value; }
        }

        // Check to see if RuleDisabled property is set
        internal bool IsSetRuleDisabled()
        {
            return this._ruleDisabled.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property RuleName. 
        /// <para>
        /// The name of the rule.
        /// </para>
        /// </summary>
        public string RuleName
        {
            get { return this._ruleName; }
            set { this._ruleName = value; }
        }

        // Check to see if RuleName property is set
        internal bool IsSetRuleName()
        {
            return this._ruleName != null;
        }

        /// <summary>
        /// Gets and sets the property TopicPattern. 
        /// <para>
        /// The pattern for the topic names that apply.
        /// </para>
        /// </summary>
        public string TopicPattern
        {
            get { return this._topicPattern; }
            set { this._topicPattern = value; }
        }

        // Check to see if TopicPattern property is set
        internal bool IsSetTopicPattern()
        {
            return this._topicPattern != null;
        }

    }
}