If you’re new to the AWS SDK for .Net/Xamarin, you’ll probably want to look first at [Getting Started with the AWS SDK for .NET/Xamarin](http://docs.aws.amazon.com/mobile/sdkforxamarin/developerguide/) which explains how to set up the SDK and how to get started using AWS Services from an Xamarin application.

After you’ve set up the SDK, you can start working with the mobile clients for Amazon Web Services. The mobile clients are described in the service-specific topics. No matter which services you’re using, you should provide AWS credentials to your app via Amazon Cognito. The Amazon Cognito credentials provider is discussed briefly in the various mobile service topics, and at length in the [Amazon Cognito Developer Guide](http://docs.aws.amazon.com/cognito/devguide/).


## Additional Resources

- [**Xamarin Developer Guide**](http://docs.aws.amazon.com/mobile/sdkforxamarin/developerguide/) - For in-depth getting started and usage information
- [**Code Sample**](https://github.com/awslabs/aws-sdk-net-samples) - Repository of example projects using the SDK.
- [**AWS Mobile Forum**](https://forums.aws.amazon.com/forum.jspa?forumID=88) – Ask questions, get help, and give feedback
- [**API Reference**](http://docs.aws.amazon.com/sdkfornet/latest/apidocs/Index.html) - For operations, parameters, responses, and examples
- [**AWS Mobile Developer Blog**](http://mobile.awsblog.com/) - For updates and guidance on using the AWS SDK for Xamarin
- [**Release Notes**](https://aws.amazon.com/releasenotes/.NET) - To see the latest features, bug fixes, and changes in the SDK
- [**Issues**](https://github.com/aws/aws-sdk-net/issues)  - Report issues and submit pull requests
- [**@awsformobile**](https://twitter.com/awsformobile) - Follow us on Twitter